//grbl
#define GRBL_INDEX_OUT         9
#define GRBL_SYNC_OUT          10
//motor encoder
#define MOTOR_ENCODER_IN       2
#define Encode_pulses_per_rev  1875

void MOTOR_ENCODER();

unsigned int MOTOR_INDEX_TEMP = 0;
unsigned int MOTOR_SYNC_TEMP = 0;

void setup() {
  pinMode(GRBL_INDEX_OUT, OUTPUT);
  pinMode(GRBL_SYNC_OUT, OUTPUT);

  pinMode(MOTOR_ENCODER_IN, INPUT);
  
  attachInterrupt(digitalPinToInterrupt(MOTOR_ENCODER_IN), MOTOR_ENCODER, RISING  );
  Serial.begin(115200);
}
//unsigned int enc = 0;
void loop()
{
  /*delay(1000);
  Serial.println(enc);
  enc = 0;*/
}

void MOTOR_ENCODER()
{
  //enc++;
  MOTOR_INDEX_TEMP++;
  MOTOR_SYNC_TEMP++;
  if( MOTOR_SYNC_TEMP == Encode_pulses_per_rev/8 )//1/8 rotation
  {
    MOTOR_SYNC_TEMP = 0;
    digitalWrite(GRBL_SYNC_OUT, HIGH);
  }
  if( MOTOR_INDEX_TEMP == Encode_pulses_per_rev )//full rotation
  {
    MOTOR_INDEX_TEMP = 0;
    digitalWrite(GRBL_INDEX_OUT, HIGH);
  }
  if( MOTOR_SYNC_TEMP == 110 )
    digitalWrite(GRBL_SYNC_OUT, LOW);
  if( MOTOR_INDEX_TEMP == 100 )
    digitalWrite(GRBL_INDEX_OUT, LOW);
}
